#version 430 core

layout (location=0) out vec4 fragColor;		// shader output

// fragment position & normal & texture coords
in vec3 position;	// in world space
in vec3 normal;		// in world space
in vec2 uvcoords;

layout (location=8)  uniform vec3 eye;				// eye position (camera)

layout (location=102) uniform samplerCube texCubeMap;   // cube map

uniform float globalBrightnessMultiplier = 1.0;

void main()
{
	vec3 vNorm = normalize(normal);	// renormalize the normal
	vec3 vView = normalize(eye - position);	// calc. normalized view vector (from position to eye)

	// cube map reflection
	vec3 vReflect = reflect(-vView, vNorm);
	fragColor = vec4(texture(texCubeMap, vReflect).rgb * globalBrightnessMultiplier, 1.0);
}
