#version 430 core

// attributes
layout(location = 0) in vec3 position_in;
layout(location = 1) in vec3 normal_in;
layout(location = 2) in vec2 uvcoords_in;

// pass through (interpolated) position & normals & uv coordinates
out vec3 position;	// in world space
out vec3 normal;	// in world space
out vec2 uvcoords;

// uniforms
layout(location = 0) uniform mat4 matModel; // model matrix
uniform mat4 matProjView; // proj*view matrix

void main()
{
	position = vec3(matModel * vec4(position_in, 1.0f));
	normal  = mat3(transpose(inverse(matModel))) * normal_in;
	uvcoords = uvcoords_in;
	gl_Position = matProjView * vec4(position, 1.0f);
}

