out vec4 fragColor;		// shader output

in vec2 tes_uvcoords;
in vec3 worldpos3;		 // world coordinates

uniform vec3 playerPos;
uniform bool playerShadow;
uniform vec3 lightDirNormed; // direction TO light; must be normalized!

uniform float globalBrightnessMultiplier = 1.0;

float mockupShadow() {
	// mock-up-shadow
	float illum = 1.0;
	if (playerShadow) {
		vec3 vPlayer = playerPos - worldpos3;
		float playerDistance = length(vPlayer);
		// calc angle between direction to player and direction to light
		float cosAngle = dot(normalize(vPlayer), lightDirNormed);

		if (cosAngle > 0) {
			float angle = acos(cosAngle);
			float d = abs(playerDistance * tan(angle));

			const float d_out = 2.5; // approx. player size
			const float d_in  = 1.5; // approx. player size
			const float il_min = .3;
			if (d < d_out) { 
				illum = il_min;
				if (d > d_in) {
					//illum = mix(il_min, 1.0, (d-d_in)/(d_out-d_in));
					illum = il_min + (1-il_min)*smoothstep(d_in, d_out, d);
				}
			}
		}
	}
	return illum * globalBrightnessMultiplier;
}

