#version 430 core

out vec2 vs_uvcoords;

uniform float patchsize;
uniform int   xpatches, zpatches;

void main() {
	const vec3 v[] = vec3[](vec3(0,0,0), vec3(1,0,0), vec3(0,0,1), vec3(1,0,1)); // order matters!

	// which patch is it ?
	int z = gl_InstanceID / xpatches;
	int x = gl_InstanceID % xpatches;

	// calc uv coordinates for patch corners
	vs_uvcoords.x =     (x + v[gl_VertexID].x) / xpatches;
	vs_uvcoords.y = 1 - (z + v[gl_VertexID].z) / zpatches;

	// calc final position of corner point
	vec3 offset = vec3(x, 0, z);
	gl_Position = vec4((v[gl_VertexID] + offset) * patchsize, 1);
}
