#version 430 core

in vec2 uvcoords;
in flat float ttl;
in flat vec4 color;

layout (location=0) out vec4 fragColor;		// shader output

uniform sampler2D tex;
uniform float particle_time = 5000.0; // millis

uniform float globalBrightnessMultiplier = 1.0;

uniform vec3 color1 = vec3(1.0,1.0,0.2);
uniform vec3 color2 = vec3(0.8,0.0,0.0);

void main() {
	float percLifetimeLeft = ttl/particle_time;

	// good:
	fragColor = texture(tex, uvcoords);
	fragColor.a = fragColor.a * percLifetimeLeft;
	fragColor.rgb *= mix(color2, color1, percLifetimeLeft) * globalBrightnessMultiplier;

	// debug:
	//fragColor.rgb = mix(vec3(1.0,0.0,0.0), vec3(0.0,0.0,1.0), percLifetimeLeft);
	//fragColor.a   = 1.0;
}

