#version 430 core

layout (points) in;
layout (triangle_strip, max_vertices=4) out;

// input from vertex shader
in vec4 vs_position_type[];
in vec4 vs_velocity_ttl[];
in vec4 vs_color[];

out vec2 uvcoords;
out flat float ttl;
out flat vec4 color;
//out float debug;

uniform mat4 matViewProj;
uniform vec3 vUp, vRight;	// camera up and right vectors
uniform float size;
uniform float particle_time = 5000.0; // millis

#define PARTICLE_TYPE_EMITTER  0.0f
#define PARTICLE_TYPE_PARTICLE 1.0f

void main() {
	if (vs_position_type[0].w == PARTICLE_TYPE_PARTICLE) {
		vec3 c = vs_position_type[0].xyz; // center of sprite
		ttl   = vs_velocity_ttl[0].w;
		color = vs_velocity_ttl[0];

		//float sz = size * (.2f + .8f * ttl/particle_time);
		float sz = size;

		vec3 p;
		p = c + sz * (-vRight + -vUp); uvcoords = vec2(0.0, 0.0); gl_Position = matViewProj * vec4(p, 1.0); EmitVertex();
		p = c + sz * ( vRight + -vUp); uvcoords = vec2(1.0, 0.0); gl_Position = matViewProj * vec4(p, 1.0); EmitVertex();
		p = c + sz * (-vRight +  vUp); uvcoords = vec2(0.0, 1.0); gl_Position = matViewProj * vec4(p, 1.0); EmitVertex();
		p = c + sz * ( vRight +  vUp); uvcoords = vec2(1.0, 1.0); gl_Position = matViewProj * vec4(p, 1.0); EmitVertex();
		EndPrimitive();
	}
}
