#version 430 core

// include is handled by shader loader
#include "lighting.h"

layout (location=0) out vec4 fragColor;		// shader output

// fragment position & normal & texture coords
in vec3 position;	// in world space
in vec3 normal;		// in world space
in vec2 uvcoords;

uniform float alpha = 1.0;

void main()
{

	vec3 vNorm = normalize(normal);	// renormalize the normal
	vec3 vView = normalize(eye - position);	// calc. normalized view vector (from position to eye)

	final_material = material;

	beginLighting();
	vec3 finalColor = finishLighting( calcDirectionalLight(dirLight[0], vView, vNorm) );
	
	fragColor = vec4(finalColor, alpha);
}
