#version 430 core

// include is handled by shader loader
#include "lighting.h"

layout (location=0) out vec4 fragColor;		// shader output

// fragment position & normal & texture coords
in vec3 position;	// in world space
in vec3 normal;		// in world space
in vec2 uvcoords;

layout (location=100) uniform sampler2D   texDiffColor; // diffuse color texture
uniform bool hasTex0;

void main()
{

	vec3 vNorm = normalize(normal);	// renormalize the normal
	vec3 vView = normalize(eye - position);	// calc. normalized view vector (from position to eye)

	// set mat_color - the material.color - to texture values, if a texture is assigned
	final_material = material;
	if (hasTex0) {
		final_material.diffuse = texture(texDiffColor, uvcoords).rgb;
		final_material.ambient = material.ambient * final_material.diffuse;
	}

	beginLighting();
	vec3 finalColor = finishLighting( calcDirectionalLight(dirLight[0], vView, vNorm) );
//finalColor=vNorm;	
	fragColor = vec4(finalColor, 1.0);
}
