#version 430 core

out vec4 fragColor;

in vec2 uv;

uniform sampler2D tex1;
uniform sampler2D tex2;
uniform vec3 blendColor = vec3(1.0);

uniform float globalBrightnessMultiplier = 1.0;

void main() {
	vec3 color = texture(tex1, uv).rgb * texture(tex2, uv).r;
	float gray =  dot(color, vec3(0.21, 0.72, 0.07));

	fragColor = vec4(gray * blendColor * globalBrightnessMultiplier, 1.0);
}
