#version 430 core

out vec4 fragColor;

in vec2 uv;

// all values in texture coordinates [0,1] !
uniform vec2 center;
uniform float radius;
uniform sampler2D tex;

uniform float globalBrightnessMultiplier = 1.0;

// params to play with
const float half_thickness = .08; //.05; //.025;
const float exponent = 0.4;

// leave this alone
const float multiplier = 1.0 / half_thickness;

void main() {
	vec2 dir = uv - center;
	float dist = length(dir);
	float radial_offset = dist - radius;
	if (abs(radial_offset) <= half_thickness) {
		float distortion_strength = 1.0 - pow(abs(radial_offset * multiplier), exponent);
		float distortion = radial_offset * distortion_strength;
		vec2 new_uv = clamp(uv + distortion * normalize(dir), 0, 1);
		fragColor = texture(tex, new_uv) * vec4(vec3(globalBrightnessMultiplier), 1.0);
	} else {
		fragColor = texture(tex, uv) * vec4(vec3(globalBrightnessMultiplier), 1.0);
	}
}
